#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <stdio.h>
#include "graphics.h"
#include "error.h"
#include "main.h"

void errorThrow(char* inMessage) {
     char tempString[256];
     
     Image* tempScreenshot = imageFromScreen();
     sprintf(tempString, "errorScreenshot.png");
     imageSave(tempString, tempScreenshot, 0);
     imageFree(tempScreenshot);
     
     SceCtrlData inputPad;
     int inputLock = 25;
     int tempInt, tempLine;
     while(1) {
          sceDisplayWaitVblankStart();
          screenClear(0xFF000000);
          
          sprintf(tempString, "ERROR!");
          screenPrintText(0, 0, tempString, 0xFF0000FF);
          
          //sprintf(tempString, "");
          tempString[0] = 0;
          tempInt = 0; tempLine = 16;
          while(inMessage[tempInt] != 0) {
               if(inMessage[tempInt] != 10) {
                    sprintf(tempString, "%s%c", tempString, inMessage[tempInt]);
               } else {
                    screenPrintText(0, tempLine, tempString, 0xFF0000FF);
                    tempLine += 8;
                    //sprintf(tempString, "");
                    tempString[0] = 0;
               }
               tempInt++;
          }
          screenPrintText(0, tempLine, tempString, 0xFF0000FF);
          tempLine += 8;
          
          sprintf(tempString, "Press [X] to continue or [O] to quit.");
          screenPrintText(0, tempLine + 16, tempString, 0xFFFFFFFF);
          
          graphicsSwapBuffers();

          if(inputLock > 0) {
               inputLock--;
          } else {
               sceCtrlReadBufferPositive(&inputPad, 1);
               if(inputPad.Buttons & PSP_CTRL_CROSS) {
                    break;
               } else if(inputPad.Buttons & PSP_CTRL_CIRCLE) {
                    terminate();
                    sceKernelExitGame();
               }
          }     
     }
}

