#include <psptypes.h>
#include <pspctrl.h>
#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <pspdisplay.h>
#include <pspkernel.h>
#include "fileBrowser.h"
#include "graphics.h"
#include "dialog.h"
#include "error.h"
#include "font.h"
#include "main.h"
#include "textbox.h"
#include "input.h"
#include "filesys.h"
#include "settings.h"

char fileBrowserCWD[512];

void fileBrowserInit() {
     sprintf(fileBrowserCWD, "ms0:");
}

char* fileBrowserOpen(int inX, int inY, char* inTitle) {
     //Image* tempBack = imageFromScreen();
     char tempString[768];
     //char tempPath[512];
     //sprintf(tempPath, "ms0:");
     char tempFile[128];
     sprintf(tempFile, "*");
     
     int tempFSel = 0;
     int tempVScroll = 0;
     
     int tempInt;
     
     if(filesysDir(fileBrowserCWD) <= 0) {
          sprintf(fileBrowserCWD, "ms0:");
          if(filesysDir(fileBrowserCWD) <= 0) {
               errorThrow("Memory stick not found.");
               return NULL;
          }
     }
     
     while(1) {
          fontSetColor(menuForeColor);
          inputPoll();
          if(inputRepeat[INPUT_CIRCLE] == 1) {
               //imageFree(tempBack);
               return NULL;
          }
          if(inputRepeat[INPUT_SQUARE] == 1) {
               if((tempFile[0] != 0) &&  (tempFile[1] != 46)) {
                    if(tempFile[0] == 47)                
                         sprintf(tempString, "%s%s", fileBrowserCWD, tempFile);
                    else
                         sprintf(tempString, "%s/%s", fileBrowserCWD, tempFile);
                    dlgConfirmDelete(tempString);
                    filesysDelete(tempString);
                    filesysDir(fileBrowserCWD);
                    tempFSel = 0;
                    tempVScroll = 0;
                    tempFile[0] = 0;
                    
               }
          }
          if(inputRepeat[INPUT_CROSS] == 1) {
               if(tempFile[0] == 47) {
                    if(tempFile[1] == 46) {
                         if(tempFile[2] == 46) {
                              tempInt = 511;
                              while((fileBrowserCWD[tempInt] != 47) && (tempInt > 0)) {
                                   fileBrowserCWD[tempInt] = 0;
                                   tempInt--;
                              }
                              fileBrowserCWD[tempInt] = 0;
                              if(fileBrowserCWD[0] == 0)
                                   sprintf(fileBrowserCWD, "ms0:");
                              filesysDir(fileBrowserCWD);
                              tempFSel = 0;
                              tempVScroll = 0;
                         }
                    } else {
                         sprintf(fileBrowserCWD, "%s%s", fileBrowserCWD, tempFile);
                         filesysDir(fileBrowserCWD);
                         tempFSel = 0;
                         tempVScroll = 0;
                    }
               } else if(strcmp(tempFile, "[New File]") == 0) {
                    sprintf(tempString, "Enter file name:");
                    char* tempNewFile = dlgTextEntry(tempString);
                    if((tempNewFile != NULL) && (tempNewFile[0] != 0)) {
                         sprintf(tempFile, "%s/%s", fileBrowserCWD, tempNewFile);
                         free(tempNewFile);
                         FILE* tempNewFilePtr = fopen(tempFile, "wb");
                         if(tempNewFilePtr != NULL) {
                              fclose(tempNewFilePtr);
                              while(filesysFileExists(tempFile) == 0) {
                                   //Empty Loop
                              }
                              //imageFree(tempBack);
                              char* tempOut = (char*) malloc((strlen(tempFile) + 1) * sizeof(char));
                              strcpy(tempOut, tempFile);
                              tempOut[strlen(tempFile)] = 0;
                              return tempOut;
                         }
                    }
               } else if(strcmp(tempFile, "[New Folder]") == 0) {
                    sprintf(tempString, "Enter folder name:");
                    char* tempNewFolder = dlgTextEntry(tempString);
                    if(tempNewFolder != NULL) {
                         sprintf(tempString, "%s/%s", fileBrowserCWD, tempNewFolder);
                         filesysMkdir(tempString);
                         filesysDir(fileBrowserCWD);
                         free(tempNewFolder);
                         tempFSel = 0;
                         tempVScroll = 0;
                    }
               } else if(tempFile[0] != 0){
                    sprintf(tempString, "%s/%s", fileBrowserCWD, tempFile);
                    char* tempOut = (char*) malloc((strlen(tempString) + 1) * sizeof(char));
                    if(tempOut == NULL) {
                         errorThrow("Couldn't create filebrowser return string.\nOut of memory.");
                         return NULL;
                    }
                    tempOut[0] = 0;
                    sprintf(tempOut, "%s", tempString);
                    //imageFree(tempBack);
                    return tempOut;
               }
          }
          if((inputRepeat[INPUT_UP] == 1) || (inputRepeat[INPUT_UP] > INPUT_REPEATRATE)) {
               if(tempFSel > 0) {
                    tempFSel--;
                    if(tempFSel < tempVScroll)
                         tempVScroll--;
               } else {
                    tempFSel = (filesysFileCount + filesysFolderCount + 1);
                    tempVScroll = tempFSel - 13;
                    if(tempVScroll < 0)
                         tempVScroll = 0;
               }
          }
          if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE)) {
               if(tempFSel < (filesysFileCount + filesysFolderCount + 1)) {
                    tempFSel++;
                    if(tempFSel > tempVScroll + 13)
                         tempVScroll++;
               } else {
                    tempFSel = 0;
                    tempVScroll = 0;
               }
          }
          
          sceDisplayWaitVblankStart();
          
          //imageDraw(0, 0, tempBack);
          graphicsCopyBuffers();
          screenDrawFilledRect(inX, inY, 360, 200, menuBackColor);
          fontPrintCenter((inY + 4), inTitle, defaultFont);
          screenDrawInvRect(inX, inY, 360, 16);
          screenDrawRect(inX, inY, 360, 200, menuBorderColor);
          screenDrawRect(inX, inY, 360, 16, menuBorderColor);

          screenDrawFilledRect((inX + 38), (inY + 18), 318, 12, txtbBackColor);
          screenDrawRect((inX + 38), (inY + 18), 318, 12, menuBorderColor);
          sprintf(tempString, "Path: %s/", fileBrowserCWD);
          fontPrint((inX + 4), (inY + 20), tempString, defaultFont);
          
          screenDrawFilledRect((inX + 4), (inY + 34), 352, 134, txtbBackColor);
          for(tempInt = tempVScroll; tempInt < (tempVScroll + 14); tempInt++) {
               if(tempFSel == tempInt) {
                    screenDrawFilledRect((inX + 4), (inY + 35 + ((tempInt - tempVScroll) * 9)), 352, 10, menuBackColor);
               }
               if(tempInt < (filesysFolderCount + filesysFileCount + 2)) {
                    if(tempInt < filesysFolderCount) {
                         sprintf(tempString, "/%s", filesysFolders[tempInt].fseName);
                    } else if(tempInt < (filesysFolderCount + filesysFileCount)) {
                         sprintf(tempString, "%s", filesysFiles[tempInt - filesysFolderCount].fseName);
                    } else if(tempInt == (filesysFolderCount + filesysFileCount)) {
                         sprintf(tempString, "[New File]");
                    } else {
                         sprintf(tempString, "[New Folder]");
                    }
                    if(tempFSel == tempInt)
                         strcpy(tempFile, tempString);
                    fontPrint((inX + 6), (inY + 36 + ((tempInt - tempVScroll) * 9)), tempString, defaultFont);
               }
               if(tempFSel == tempInt) {
                    screenDrawInvRect((inX + 4), (inY + 35 + ((tempInt - tempVScroll) * 9)), 352, 10);
               }
          }
          screenDrawRect((inX + 4), (inY + 34), 352, 134, 0xFF000000);          
          
          sprintf(tempString, "File:");
          fontPrint((inX + 4), (inY + 172), tempString, defaultFont);
          screenDrawFilledRect((inX + 38), (inY + 170), 318, 12, txtbBackColor);
          screenDrawRect((inX + 38), (inY + 170), 318, 12, menuBorderColor);
          fontSetColor(txtbForeColor);
          if(tempFile[0] == 47) {
               sprintf(tempString, "%s%s/", fileBrowserCWD, tempFile);
          } else {
               sprintf(tempString, "%s/%s", fileBrowserCWD, tempFile);
          }
          fontPrint((inX + 42), (inY + 172), tempString, defaultFont);
          
          fontSetColor(menuForeColor);
          sprintf(tempString, "[%c] Delete [%c] Ok  [%c] Cancel", ASCII_SQUARE, ASCII_CROSS, ASCII_CIRCLE);
          fontPrint((inX + 143), (inY + 188), tempString, defaultFont);
          
          graphicsSwapBuffers();
     }
}
