#ifndef FONT_H
#define FONT_H

#include <psptypes.h>
#include "graphics.h"

#define FONT_ALPHA_COLOR 0xFFFF00FF
#define FONT_ALPHA_UPPER_COLOR 0xFF0000FF
#define FONT_ALPHA_LOWER_COLOR 0xFF00FF00


typedef struct {
       Image* fontData;
       int fontWidth, fontHeight;
       Color fontFiller;
       int fontHSpace, fontVSpace;
} Font;

extern void fontPrint(int inX, int inY, char* inString, Font* inFont);
extern void fontPrintChar(int inX, int inY, unsigned char inChar, Font* inFont);
extern void fontPrintFromRight(int inX, int inY, char* inString, Font* inFont);
extern void fontPrintCenter(int inY, char* inString, Font* inFont);
extern void fontPrintCenterMultiline(int inY, char* inString, Font* inFont);
extern Font* fontLoad(char* inPath, int inHSpace, int inVSpace);
extern void fontSetColor(Color inColor);
extern void fontFree(Font* inFont);
extern void fontInvertColor();

#endif
