#include <pspctrl.h>
#include "input.h"
#include "main.h"
#include "dialog.h"
#include "timer.h"


float inputRepeat[12];
float inputTick = 0;
Timer* inputTimer;
SceCtrlData inputPad;

void inputInit() {
     unsigned char tempLoop;
     for(tempLoop = 0; tempLoop < 12; tempLoop++) {
          inputRepeat[tempLoop] = 0;
     }
     inputTimer = timerCreate();
}

void inputRepeatIncr(int inState) {
     if(inputRepeat[inState] <= 0)
          inputRepeat[inState] = 1;
     else
          inputRepeat[inState] += inputTick;
}

void inputPoll() {
     inputTick = timerGetDeltaTime(inputTimer);
     sceCtrlReadBufferPositive(&inputPad, 1);
     
     if((inputPad.Buttons & PSP_CTRL_SQUARE) != FALSE)
          inputRepeatIncr(INPUT_SQUARE);
     else
          inputRepeat[INPUT_SQUARE] = 0;
     if((inputPad.Buttons & PSP_CTRL_TRIANGLE) != FALSE)
          inputRepeatIncr(INPUT_TRIANGLE);
     else
          inputRepeat[INPUT_TRIANGLE] = 0;
     if((inputPad.Buttons & PSP_CTRL_CIRCLE) != FALSE)
          inputRepeatIncr(INPUT_CIRCLE);
     else
          inputRepeat[INPUT_CIRCLE] = 0;
     if((inputPad.Buttons & PSP_CTRL_CROSS) != FALSE)
          inputRepeatIncr(INPUT_CROSS);
     else
          inputRepeat[INPUT_CROSS] = 0;

     if((inputPad.Buttons & PSP_CTRL_LEFT) != FALSE)
          inputRepeatIncr(INPUT_LEFT);
     else
         inputRepeat[INPUT_LEFT] = 0;
     if((inputPad.Buttons & PSP_CTRL_RIGHT) != FALSE)
          inputRepeatIncr(INPUT_RIGHT);
     else
          inputRepeat[INPUT_RIGHT] = 0;
     if((inputPad.Buttons & PSP_CTRL_UP) != FALSE)
          inputRepeatIncr(INPUT_UP);
     else
          inputRepeat[INPUT_UP] = 0;
     if((inputPad.Buttons & PSP_CTRL_DOWN) != FALSE)
          inputRepeatIncr(INPUT_DOWN);
     else
          inputRepeat[INPUT_DOWN] = 0;
          
     if((inputPad.Buttons & PSP_CTRL_LTRIGGER) != FALSE)
          inputRepeatIncr(INPUT_LTRIGGER);
     else
          inputRepeat[INPUT_LTRIGGER] = 0;
     if((inputPad.Buttons & PSP_CTRL_RTRIGGER) != FALSE)
          inputRepeatIncr(INPUT_RTRIGGER);
     else
          inputRepeat[INPUT_RTRIGGER] = 0;
     if((inputPad.Buttons & PSP_CTRL_START) != FALSE)
          inputRepeatIncr(INPUT_START);
     else
          inputRepeat[INPUT_START] = 0;
     if((inputPad.Buttons & PSP_CTRL_SELECT) != FALSE)
          inputRepeatIncr(INPUT_SELECT);
     else
          inputRepeat[INPUT_SELECT] = 0;
          
     unsigned char i;
     for(i = 0; i < 12; i++) {
          if(inputRepeat[i] > INPUT_REPEATRATE)
               inputRepeat[i] = INPUT_REPEATRATE + 0.1;
     }
     
     if(inputRepeat[INPUT_SELECT] == 1)
               dlgScreenshot();
     if(inputRepeat[INPUT_START] == 1)
               stateSave();
}

char inputJustPressed(int inButton) {
     float tempVal = 0;
     if(inputRepeat[inButton] > 0) {
          tempVal = 1 - inputRepeat[inButton];
          if(tempVal < 0.03125)
               return 1;
     }
     return 0;
}

char inputJustPressedOrRepeat(int inButton) {
     float tempVal = 0;
     if(inputRepeat[inButton] > 0) {
          tempVal = 1 - inputRepeat[inButton];
          if(tempVal < 0.03125)
               return 1;
          if(tempVal > INPUT_REPEATRATE)
               return 1;
     }
     return 0;
}

void inputDeInit() {
     timerFree(inputTimer);
}
