#include <psptypes.h>
#include <stdio.h>
#include <string.h>
#include <pspctrl.h>
#include <malloc.h>
#include "graphics.h"
#include "keyboard.h"
#include "graphics.h"
#include "main.h"
#include "error.h"
#include "textbox.h"
#include "input.h"
#include "settings.h"

Image* keybImgHi;
Image* keybImgLo;

unsigned char keybLetterVals[112] = { 
         170,  33,  34, 156,  36,  37,  94,  38,  42,  40,  41,  95,  43,   8,
           9,  81,  87,  69,  82,  84,  89,  85,  73,  79,  80, 123, 125,  10,
          15,  65,  83,  68,  70,  71,  72,  74,  75,  76,  58,  64, 126,  10,
         124,  90,  88,  67,  86,  66,  78,  77,  60,  62,  63,  32,  32,  32,
          96,  49,  50,  51,  52,  53,  54,  55,  56,  57,  48,  45,  61,   8,
           9, 113, 119, 101, 114, 116, 121, 117, 105, 111, 112,  91,  93,  10,
          15,  97, 115, 100, 102, 103, 104, 106, 107, 108,  59,  39,  35,  10,
          92, 122, 120,  99, 118,  98, 110, 109,  44,  46,  47,  32,  32,  32
         };

void keybInit() {
     char tempPath[256];
     sprintf(tempPath, "skins/%s/keybHi.png", skinPath);
     keybImgHi = imageLoad(tempPath);
     sprintf(tempPath, "skins/%s/keybLo.png", skinPath);
     keybImgLo = imageLoad(tempPath);
}

Keyboard* keybCreate(int inLeft, int inTop) {
     Keyboard* tempKeyboard = (Keyboard*) malloc(sizeof(Keyboard));
     tempKeyboard->keybBuffer[0] = 0;
     tempKeyboard->keybTop = inTop;
     tempKeyboard->keybLeft = inLeft;
     tempKeyboard->keybCaps = 0;
     tempKeyboard->keybFocus = 0;
     tempKeyboard->keybColSel = 0;
     return tempKeyboard;
}

void keybDraw(Keyboard* inKeyboard) {
     imageDraw(inKeyboard->keybLeft, inKeyboard->keybTop, (inKeyboard->keybCaps == FALSE ? keybImgLo : keybImgHi));

     if(inKeyboard->keybFocus != FALSE) {
          screenDrawRect(inKeyboard->keybLeft + 7 + (inKeyboard->keybColSel << 3), inKeyboard->keybTop, 9, keybImgLo->imageHeight, 0xFF0000FF);
     }
}

void keybTick(Keyboard* inKeyboard) {
     if(inKeyboard->keybFocus == FALSE)
          return;
     
     if(inputRepeat[INPUT_UP] == 1)
          inKeyboard->keybCaps = !inKeyboard->keybCaps;
     if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE))
          keybBufferPush(inKeyboard, ASCII_SPACE);
     if((inputRepeat[INPUT_RIGHT] == 1) || (inputRepeat[INPUT_RIGHT] > INPUT_REPEATRATE)) {
          if(inKeyboard->keybColSel < 13)
               inKeyboard->keybColSel++;
          else
               inKeyboard->keybColSel = 0;
     }
     if((inputRepeat[INPUT_LEFT] == 1) || (inputRepeat[INPUT_LEFT] > INPUT_REPEATRATE)) {
          if(inKeyboard->keybColSel > 0)
               inKeyboard->keybColSel--;
          else
               inKeyboard->keybColSel = 13;
     }
     
     if((inputRepeat[INPUT_SQUARE] == 1) || (inputRepeat[INPUT_SQUARE] > INPUT_REPEATRATE)) {
          if(inKeyboard->keybCaps != FALSE)
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel]);
          else
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 56]);
     }
     if((inputRepeat[INPUT_TRIANGLE] == 1) || (inputRepeat[INPUT_TRIANGLE] > INPUT_REPEATRATE)) {
          if(inKeyboard->keybCaps != FALSE)
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 14]);
          else
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 70]);
     }
     if((inputRepeat[INPUT_CIRCLE] == 1) || (inputRepeat[INPUT_CIRCLE] > INPUT_REPEATRATE)) {
          if(inKeyboard->keybCaps != FALSE)
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 28]);
          else
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 84]);
     }
     if((inputRepeat[INPUT_CROSS] == 1) || (inputRepeat[INPUT_CROSS] > INPUT_REPEATRATE)) {
          if(inKeyboard->keybCaps != FALSE)
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 42]);
          else
               keybBufferPush(inKeyboard, keybLetterVals[inKeyboard->keybColSel + 98]);
     }
}

void keybBufferPush(Keyboard* inKeyboard, unsigned char inChar) {
     if(inChar == ASCII_SHIFT_IN) {
          inKeyboard->keybCaps = !inKeyboard->keybCaps;
          return;
     }
     int tempInt;
     for(tempInt = 0; tempInt < 255; tempInt++)
          inKeyboard->keybBuffer[tempInt + 1] = inKeyboard->keybBuffer[tempInt];
     inKeyboard->keybBuffer[0] = inChar;
}

unsigned char keybBufferPop(Keyboard* inKeyboard) {
     int tempPtr = 0;
     if(inKeyboard->keybBuffer[0] == 0)
          return 0;
     while((tempPtr < 255) && (inKeyboard->keybBuffer[tempPtr + 1] != 0))
          tempPtr++;
     unsigned char tempOut = inKeyboard->keybBuffer[tempPtr];
     inKeyboard->keybBuffer[tempPtr] = 0;
     return tempOut;
}

void keybFree(Keyboard* inKeyboard) {
     free(inKeyboard);
}
