#ifndef KEYBOARD_H
#define KEYBOARD_H

#include <psptypes.h>

typedef struct {
     char keybCaps;
     char keybFocus;
     int keybLeft;
     int keybTop;
     unsigned char keybColSel;
     unsigned char keybBuffer[256];
} Keyboard;

extern Image* keybImgHi;
extern Image* keybImgLo;

extern void keybInit();
extern Keyboard* keybCreate(int inLeft, int inTop);
extern void keybDraw(Keyboard* inKeyboard);
extern void keybTick(Keyboard* inKeyboard);
extern void keybFree(Keyboard* inKeyboard);
extern void keybBufferPush(Keyboard* inKeyboard, unsigned char inChar);
extern unsigned char keybBufferPop(Keyboard* inKeyboard);

#endif
