#ifndef MAIN_H
#define MAIN_H

#include <psptypes.h>
#include <pspctrl.h>
#include "font.h"
#include "textbox.h"
#include "keyboard.h"
#include "sprite.h"


#define MAX(X, Y) ((X) > (Y) ? (X) : (Y))
#define MIN(X, Y) ((X) < (Y) ? (X) : (Y))

#define bool char
#define false 0
#define true !false
#define FALSE 0
#define TRUE !FALSE

#define SCREEN_WIDTH 480
#define SCREEN_HEIGHT 272

#define ASCII_NULL 0
#define ASCII_AUDIBLE_BELL 7
#define ASCII_BS 8
#define ASCII_TAB 9
#define ASCII_LF 10
#define ASCII_CR 13
#define ASCII_SHIFT_OUT 14
#define ASCII_SHIFT_IN 15
#define ASCII_SPACE 32

#define ASCII_SQUARE 17
#define ASCII_TRIANGLE 18
#define ASCII_CIRCLE 19
#define ASCII_CROSS 20

#define ASCII_UP 28
#define ASCII_DOWN 29
#define ASCII_LEFT 30
#define ASCII_RIGHT 31

#define ASCII_A 65
#define ASCII_Z 90
#define ASCII_a 97
#define ASCII_z 122

#define ASCII_MENU_EXPAND 16

#define COLOR_ALPHA 0xFFFF00FF

#define VERSION_MAJOR 1
#define VERSION_MINOR 6
#define VERSION_REVISION 0

extern Font* defaultFont;
extern TextBox* txtbMain;
extern Keyboard* keybMain;
extern Sprite* keyrefDPad;
extern Sprite* keyrefButtons;
extern Sprite* keyrefPadDesc;

extern void terminate();
extern void stateSave();
extern void stateLoad();
extern void renderLoop();

#endif
