#include <psptypes.h>
#include <stdio.h>
#include <string.h>
#include <pspkernel.h> 
#include <pspdisplay.h>
#include <malloc.h>
#include "graphics.h"
#include "menu.h"
#include "graphics.h"
#include "main.h"
#include "error.h"
#include "input.h"
#include "textbox.h"
#include "dialog.h"
#include "filesys.h"
#include "fileBrowser.h"
#include "recentFiles.h"
#include "settings.h"

Image* menuBackImg;
char menuFocus = FALSE;
unsigned char menuSel = 0;
char menuSideScroll = 0;

void menuInit() {
     char tempPath[256];
     if(keybEnabled == FALSE)
          sprintf(tempPath, "skins/%s/menuBackNoKeyb.png", skinPath);
     else
          sprintf(tempPath, "skins/%s/menuBack.png", skinPath);
     menuBackImg = imageLoad(tempPath);
     imageReplaceColor(0xFFFF00FF, 0x00FFFFFF, menuBackImg);
}

void menuDraw() {
     imageDrawAlpha(0, 0, menuBackImg);
     fontSetColor(menuForeColor);
     char tempString[256];
     
     if(txtbMain->txtbPath[0] == 0) {
          sprintf(tempString, "[untitled.txt]");
     } else {
          char* tempFName = filesysFileNameFromPath(txtbMain->txtbPath);
          sprintf(tempString, "%s", tempFName);
          free(tempFName);
     }
     if(txtbMain->txtbChanged != 0)
          sprintf(tempString, "%s*", tempString);
     fontPrint(136, 2, tempString, defaultFont);
     
     if(menuFocus != FALSE) {
          if(menuSel < 4) {
               screenDrawInvRect((menuSel << 5), 0, 32, 13);
          } else {
               screenDrawInvRect((SCREEN_WIDTH - 16), 0, 16, 13);
          }
     }
     
     float tempScrollLoc = 0;
     if((txtbMain->txtbLineCount - 1) == 0) {
          mnuDrawScrollBlock(txtbMain->txtbLeft + txtbMain->txtbWidth, txtbMain->txtbTop + 8, 8, 8);
     } else {
          tempScrollLoc = txtbMain->txtbTop + 8;
          tempScrollLoc += ((txtbMain->txtbSelRow * (txtbMain->txtbHeight - 24)) / (txtbMain->txtbLineCount - 1));
          mnuDrawScrollBlock(txtbMain->txtbLeft + txtbMain->txtbWidth, tempScrollLoc, 8, 8);
     }
     if(txtbMain->txtbLineMaxWidth == 0) {
          mnuDrawScrollBlock(txtbMain->txtbLeft + 8, txtbMain->txtbTop + txtbMain->txtbHeight, 8, 8);
     } else {
          tempScrollLoc = txtbMain->txtbLeft + 8;
          tempScrollLoc += ((txtbMain->txtbSelCol * (txtbMain->txtbWidth - 24)) / (txtbMain->txtbLineMaxWidth));
          mnuDrawScrollBlock(tempScrollLoc, txtbMain->txtbTop + txtbMain->txtbHeight, 8, 8);
     }
}

void menuTick() {
     if(menuSideScroll != 0) {
          if(menuFocus != FALSE) {
               graphicsSwapBuffers();
               if(menuSel < 4) {
                    screenDrawInvRect((menuSel << 5), 0, 32, 13);
               } else {
                    screenDrawInvRect((SCREEN_WIDTH - 16), 0, 16, 13);
               }
               graphicsSwapBuffers();
          }
          if(menuSideScroll > 0) {
               if(menuSel < 4)
                    menuSel++;
               else
                    menuSel = 0;
          } else if(menuSideScroll < 0) {
               if(menuSel > 0)
                    menuSel--;
               else
                    menuSel = 4;
          }
          menuSideScroll = 0;
          if(menuFocus != FALSE) {
               graphicsSwapBuffers();
               if(menuSel < 4) {
                    screenDrawInvRect((menuSel << 5), 0, 32, 13);
               } else {
                    screenDrawInvRect((SCREEN_WIDTH - 16), 0, 16, 13);
               }
               graphicsSwapBuffers();
          }
          switch(menuSel) {
               case 0:
                    mnuFileMenu(0, 13);
                    break;
               case 1:
                    mnuEditMenu(32, 13);
                    break;
               case 2:
                    mnuToolsMenu(64, 13);
                    break;
               case 3:
                    mnuHelpMenu(96, 13);
                    break;
          }
          return;
     }
     
     if(menuFocus != FALSE) {
          if((inputRepeat[INPUT_LEFT] == 1) || (inputRepeat[INPUT_LEFT] > INPUT_REPEATRATE)) {
               if(menuSel > 0)
                    menuSel--;
               else
                    menuSel = 4;
          }
          if((inputRepeat[INPUT_RIGHT] == 1) || (inputRepeat[INPUT_RIGHT] > INPUT_REPEATRATE)) {
               if(menuSel < 4)
                     menuSel++;
               else
                     menuSel = 0;
          }
          if((inputRepeat[INPUT_CROSS] == 1) && (menuSel == 4))
               terminate();
          if((inputRepeat[INPUT_CROSS] == 1) || (inputRepeat[INPUT_DOWN] == 1)) {
               switch(menuSel) {
                    case 0:
                         mnuFileMenu(0, 13);
                         break;
                    case 1:
                         mnuEditMenu(32, 13);
                         break;
                    case 2:
                         mnuToolsMenu(64, 13);
                         break;
                    case 3:
                         mnuHelpMenu(96, 13);
                         break;
               }
          }
     } else {
          menuSel = 0;
     }
}

void mnuFileMenu(int inX, int inY) {
     char tempString[256];
     unsigned char tempSel = 0;

     while(1) {
          inputPoll();
          sceDisplayWaitVblankStart();
          graphicsCopyBuffers();
          screenDrawFilledRect(inX, inY, 120, 88, menuBackColor);
          screenDrawRect(inX, inY, 120, 88, menuBorderColor);
          fontSetColor(menuForeColor);

          sprintf(tempString, "New");
          fontPrint((inX + 4), (inY + 4), "New", defaultFont);
          sprintf(tempString, "Open...");
          fontPrint((inX + 4), (inY + 16), tempString, defaultFont);
          sprintf(tempString, "Recent         %c", ASCII_MENU_EXPAND);
          fontPrint((inX + 4), (inY + 28), tempString, defaultFont);
          sprintf(tempString, "Save");
          fontPrint((inX + 4), (inY + 40), tempString, defaultFont);
          sprintf(tempString, "Save As...");
          fontPrint((inX + 4), (inY + 52), tempString, defaultFont);
          sprintf(tempString, "----------------");
          fontSetColor(0xFF808080);
          fontPrint((inX + 4), (inY + 64), tempString, defaultFont);
          fontSetColor(menuForeColor);
          sprintf(tempString, "Exit");
          fontPrint((inX + 4), (inY + 76), tempString, defaultFont);
          
          screenDrawInvRect((inX + 1), (inY + 2 + (tempSel * 12)), 118, 12);
          
          if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE)) {
               if(tempSel < 6)
                    tempSel++;
               else
                    tempSel = 0;
          }
          if((inputRepeat[INPUT_UP] == 1) || (inputRepeat[INPUT_UP] > INPUT_REPEATRATE)) {
               if(tempSel > 0)
                    tempSel--;
               else
                    tempSel = 6;
          }

          if(inputRepeat[INPUT_CROSS] == 1) {
               if(tempSel == 0) {
                         if((txtbMain->txtbChanged == FALSE) || (dlgConfirmClear() != 0)) {
                              txtbClear(txtbMain);
                         }
                         return;
               } else if(tempSel == 1) {
                         if((txtbMain->txtbChanged == FALSE) || (dlgConfirmClear() != 0)) {
                              char* tempOpenFile = fileBrowserOpen(60, 36, "Open ASCII Text File...");
                              if(tempOpenFile != NULL) {
                                   txtbOpen(txtbMain, tempOpenFile, 0);
                                   recentFilesAdd(tempOpenFile);
                                   free(tempOpenFile);
                              }
                         }
                          return;
               } else if(tempSel == 2) {
                          mnuFileRecentMenu(inX + 119, inY + 28);
                          return;
               } else if(tempSel == 3) {
                         if(txtbMain->txtbPath[0] != 0) {
                              txtbSave(txtbMain, txtbMain->txtbPath, 0);
                              return;
                         }
               } else if(tempSel == 4) {
                         char* tempSaveFile = fileBrowserOpen(60, 36, "Save ASCII Text File...");
                         if((filesysFileExists(tempSaveFile) == 0) || (dlgConfirmOverwrite() != 0)) {
                              if(tempSaveFile != NULL) {
                                   txtbSave(txtbMain, tempSaveFile, 0);
                                   recentFilesAdd(tempSaveFile);
                                   free(tempSaveFile);
                              }
                         }
                         return;
               } else if(tempSel == 6) {
                         terminate();
                         break;
               }
          }
          
          if(inputRepeat[INPUT_CIRCLE] == 1)
               return;
          if(inputRepeat[INPUT_LEFT] == 1) {
               menuSideScroll = -1;
               return;
          }
          if(inputRepeat[INPUT_RIGHT] == 1) {
               if(tempSel == 2)
                    mnuFileRecentMenu(inX + 120, inY + 28);
               else
                    menuSideScroll = 1;
               return;
          }
          
          graphicsSwapBuffers();
     }
}

void mnuEditMenu(int inX, int inY) {
     char tempString[256];
     unsigned char tempSel = 0;

     while(1) {
          inputPoll();
          sceDisplayWaitVblankStart();
          graphicsCopyBuffers();
          screenDrawFilledRect(inX, inY, 120, 64, menuBackColor);
          screenDrawRect(inX, inY, 120, 64, menuBorderColor);
          fontSetColor(menuForeColor);

          sprintf(tempString, "Cut");
          fontPrint((inX + 4), (inY + 4), tempString, defaultFont);
          sprintf(tempString, "Copy");
          fontPrint((inX + 4), (inY + 16), tempString, defaultFont);
          sprintf(tempString, "Paste");
          fontPrint((inX + 4), (inY + 28), tempString, defaultFont);
          sprintf(tempString, "Delete");
          fontPrint((inX + 4), (inY + 40), tempString, defaultFont);
          sprintf(tempString, "Select All");
          fontPrint((inX + 4), (inY + 52), tempString, defaultFont);
          
          screenDrawInvRect((inX + 1), (inY + 2 + (tempSel * 12)), 118, 12);
          
          if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE)) {
               if(tempSel < 4)
                    tempSel++;
               else
                    tempSel = 0;
          }
          if((inputRepeat[INPUT_UP] == 1) || (inputRepeat[INPUT_UP] > INPUT_REPEATRATE)) {
               if(tempSel > 0)
                    tempSel--;
               else
                    tempSel = 4;
          }
          if(inputRepeat[INPUT_CROSS] == 1) {
               switch(tempSel) {
                    case 0:
                         txtbCut(txtbMain);
                         return;
                    case 1:
                         txtbCopy(txtbMain);
                         return;
                    case 2:
                         txtbPaste(txtbMain);
                         return;
                    case 3:
                         txtbDelete(txtbMain);
                         return;
                    case 4:
                         txtbSelectAll(txtbMain);
                         return;
               }
          }
          
          if(inputRepeat[INPUT_CIRCLE] == 1)
               return;
          if(inputRepeat[INPUT_LEFT] == 1) {
               menuSideScroll = -1;
               return;
          }
          if(inputRepeat[INPUT_RIGHT] == 1) {
               menuSideScroll = 1;
               return;
          }
          
          graphicsSwapBuffers();
     }
}

void mnuToolsMenu(int inX, int inY) {
     char tempString[256];
     unsigned char tempSel = 0;
     int tempInt = 0;

     while(1) {
          inputPoll();
          sceDisplayWaitVblankStart();
          graphicsCopyBuffers();
          screenDrawFilledRect(inX, inY, 120, 100, menuBackColor);
          screenDrawRect(inX, inY, 120, 100, menuBorderColor);
          fontSetColor(menuForeColor);

          sprintf(tempString, "Insert symbol...");
          fontPrint((inX + 4), (inY + 4), tempString, defaultFont);
          sprintf(tempString, "Find...");
          fontPrint((inX + 4), (inY + 16), tempString, defaultFont);
          sprintf(tempString, "Replace...");
          fontPrint((inX + 4), (inY + 28), tempString, defaultFont);
          sprintf(tempString, "Goto Line...");
          fontPrint((inX + 4), (inY + 40), tempString, defaultFont);
          sprintf(tempString, "----------------");
          fontSetColor(0xFF808080);
          fontPrint((inX + 4), (inY + 52), tempString, defaultFont);
          sprintf(tempString, "Settings...");
          fontSetColor(menuForeColor);
          fontPrint((inX + 4), (inY + 64), tempString, defaultFont);
          sprintf(tempString, "----------------");
          fontSetColor(0xFF808080);
          fontPrint((inX + 4), (inY + 76), tempString, defaultFont);
          fontSetColor(menuForeColor);
          sprintf(tempString, "Run as lua...");
          if(filesysFileExists("plugins/LUAPLAYER.PBP") != 0) {
               fontPrint((inX + 4), (inY + 88), tempString, defaultFont);
          } else {
               fontSetColor(0xFF808080);
               fontPrint((inX + 4), (inY + 88), tempString, defaultFont);
               fontSetColor(menuForeColor);
          }
          
          screenDrawInvRect((inX + 1), (inY + 2 + (tempSel * 12)), 118, 12);
          
          if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE)) {
               if(tempSel < 7)
                    tempSel++;
               else
                    tempSel = 0;
          }
          if((inputRepeat[INPUT_UP] == 1) || (inputRepeat[INPUT_UP] > INPUT_REPEATRATE)) {
               if(tempSel > 0)
                    tempSel--;
               else
                    tempSel = 7;
          }
          if(inputRepeat[INPUT_CROSS] == 1) {
               switch(tempSel) {
                    case 0:
                         tempInt = dlgInsertSymbol();
                         if(tempInt >= 0)
                              txtbInsertChar(txtbMain, tempInt);
                         return;
                    case 1:
                         dlgFind();
                         return;
                    case 2:
                         dlgReplace();
                         return;
                    case 3:
                         tempInt = dlgGotoLine();
                         if(tempInt >= 0)
                              txtbGotoLine(txtbMain, tempInt);
                         return;
                    case 5:
                         if((txtbMain->txtbChanged == 0) || (dlgHelp("settings.cfg") != 0))
                              txtbOpen(txtbMain, "settings/settings.cfg", 1);
                         return;
                    case 7:
                         
                         return;
               }
          }
          if(inputRepeat[INPUT_CIRCLE] == 1)
               return;
          if(inputRepeat[INPUT_LEFT] == 1) {
               menuSideScroll = -1;
               return;
          }
          if(inputRepeat[INPUT_RIGHT] == 1) {
               menuSideScroll = 1;
               return;
          }

          
          graphicsSwapBuffers();
     }
}


void mnuHelpMenu(int inX, int inY) {
     char tempString[256];
     unsigned char tempSel = 0;

     while(1) {
          inputPoll();
          sceDisplayWaitVblankStart();
          graphicsCopyBuffers();
          screenDrawFilledRect(inX, inY, 120, 64, menuBackColor);
          screenDrawRect(inX, inY, 120, 64, menuBorderColor);
          fontSetColor(menuForeColor);
          
          sprintf(tempString, "Readme...");
          fontPrint((inX + 4), (inY + 4), tempString, defaultFont);
          sprintf(tempString, "Copying...");
          fontPrint((inX + 4), (inY + 16), tempString, defaultFont);
          sprintf(tempString, "Credits...");
          fontPrint((inX + 4), (inY + 28), tempString, defaultFont);
          sprintf(tempString, "----------------");
          fontSetColor(0xFF808080);
          fontPrint((inX + 4), (inY + 40), tempString, defaultFont);
          fontSetColor(menuForeColor);
          sprintf(tempString, "About...");
          fontPrint((inX + 4), (inY + 52), tempString, defaultFont);
          
          screenDrawInvRect((inX + 1), (inY + 2 + (tempSel * 12)), 118, 12);
          
          if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE)) {
               if(tempSel < 4)
                    tempSel++;
               else
                    tempSel = 0;
          }
          if((inputRepeat[INPUT_UP] == 1) || (inputRepeat[INPUT_UP] > INPUT_REPEATRATE)) {
               if(tempSel > 0)
                    tempSel--;
               else
                    tempSel = 4;
          }
          if(inputRepeat[INPUT_CROSS] == 1) {
               switch(tempSel) {
                    case 0:
                         if((txtbMain->txtbChanged == 0) || (dlgHelp("README") != 0))
                              txtbOpen(txtbMain, "README", 1);
                         return;
                    case 1:
                         if((txtbMain->txtbChanged == 0) || (dlgHelp("COPYING") != 0))
                              txtbOpen(txtbMain, "COPYING", 1);
                         return;
                    case 2:
                         dlgCredits();
                         return;
                    case 4:
                         dlgAbout();
                         return;
               }
          }

          if(inputRepeat[INPUT_CIRCLE] == 1)
               return;
          if(inputRepeat[INPUT_LEFT] == 1) {
               menuSideScroll = -1;
               return;
          }
          if(inputRepeat[INPUT_RIGHT] == 1) {
               menuSideScroll = 1;
               return;
          }
          
          graphicsSwapBuffers();
     }
}

void mnuFileRecentMenu(int inX, int inY) {
     char tempString[256];
     unsigned char tempSel = 0;
     int tempInt = 0;
     char* tempRecent = NULL;
     char* tempRecentName = NULL;

     while(1) {
          inputPoll();
          sceDisplayWaitVblankStart();
          graphicsCopyBuffers();
          screenDrawFilledRect(inX, inY, 180, 124, menuBackColor);
          screenDrawRect(inX, inY, 180, 124, menuBorderColor);
          fontSetColor(menuForeColor);

          for(tempInt = 0; tempInt < 10; tempInt++) {
               tempRecent = recentFilesGet(tempInt);
               if((tempRecent == NULL) || (tempRecent[0] == 0)) {
                    sprintf(tempString, "%i. %s", (tempInt + 1), "<None>");
               } else {
                    tempRecentName = filesysFileNameFromPath(tempRecent);
                    sprintf(tempString, "%i. %s", (tempInt + 1), tempRecentName);
                    free(tempRecentName);
               }
               fontPrint((inX + 4), (inY + 4 + (12 * tempInt)), tempString, defaultFont);
          }
          
          screenDrawInvRect((inX + 1), (inY + 2 + (tempSel * 12)), 178, 12);
          
          if((inputRepeat[INPUT_DOWN] == 1) || (inputRepeat[INPUT_DOWN] > INPUT_REPEATRATE)) {
               if(tempSel < 9)
                    tempSel++;
               else
                    tempSel = 0;
          }
          if((inputRepeat[INPUT_UP] == 1) || (inputRepeat[INPUT_UP] > INPUT_REPEATRATE)) {
               if(tempSel > 0)
                    tempSel--;
               else
                    tempSel = 9;
          }

          if(inputRepeat[INPUT_CROSS] == 1) {
               tempRecent = recentFilesGet(tempSel);
               if((tempRecent == NULL) || (tempRecent[0] == 0))
                    return;
               txtbOpen(txtbMain, tempRecent, 0);
               return;
          }
          
          if(inputRepeat[INPUT_CIRCLE] == 1)
               return;
          if(inputRepeat[INPUT_LEFT] == 1) {
               return;
          }
          if(inputRepeat[INPUT_RIGHT] == 1) {
               return;
          }
          
          graphicsSwapBuffers();
     }
}

void mnuDrawScrollBlock(int inX, int inY, int inWidth, int inHeight) {
     screenDrawFilledRect((inX + 2), (inY + 2), (inWidth - 3), (inHeight - 3), colorMerge(menuBackColor, menuBorderColor));
     screenDrawFilledRect((inX + 1), (inY + 1), (inWidth - 3), (inHeight - 3), colorMerge(menuBackColor, colorInvert(menuBorderColor)));
     screenDrawFilledRect((inX + 2), (inY + 2), (inWidth - 4), (inHeight - 4), menuBackColor);
     screenDrawRect(inX, inY, inWidth, inHeight, menuBorderColor);
}
