#include <stdio.h>
#include <stdlib.h>
#include "plugins.h"
#include "keyboard.h"
#include "textBox.h"
#include "fileBrowser.h"
#include "dialog.h"
#include "recentFiles.h"
#include "filesys.h"

void plugin_Keyboard_AddChar(unsigned char inChar) {
     keybBufferPush(keybMain, inChar);
}

void plugin_Keyboard_Backspace() {
     txtbBackSpace(txtbMain);
}

void plugin_Keyboard_Cut() {
     txtbCut(txtbMain);
}

void plugin_Keyboard_Copy() {
     txtbCopy(txtbMain);
}

void plugin_Keyboard_Paste() {
     txtbPaste(txtbMain);
     
}

void plugin_Keyboard_Delete() {
     txtbDelete(txtbMain);
}

void plugin_Keyboard_Insert() {
     txtbMain->txtbOvrMode = !txtbMain->txtbOvrMode;
}

void plugin_Keyboard_Home() {
     txtbHome(txtbMain);
}

void plugin_Keyboard_End() {
     txtbEnd(txtbMain);
}

void plugin_Keyboard_PageUp() {
     txtbPageUp(txtbMain);
}

void plugin_Keyboard_PageDown() {
     txtbPageDown(txtbMain);
}

void plugin_Keyboard_Menu() {

}

void plugin_Keyboard_Left(keyState inState) {
     //txtbCursorMoveLeft(txtbMain);
}

void plugin_Keyboard_Right(keyState inState) {
     //txtbCursorMoveRight(txtbMain);
}

void plugin_Keyboard_Up(keyState inState) {
     //txtbCursorMoveUp(txtbMain);
}

void plugin_Keyboard_Down(keyState inState) {
     //txtbCursorMoveDown(txtbMain);
}

void plugin_Keyboard_Select(keyState inState) {
     
}

void plugin_Keyboard_Cancel(keyState inState) {

}



void plugin_Keyboard_Open() {
     char* tempOpenFile = fileBrowserOpen(60, 36, "Open ASCII Text File...");
     if(tempOpenFile != NULL) {
          txtbOpen(txtbMain, tempOpenFile, 0);
          recentFilesAdd(tempOpenFile);
          free(tempOpenFile);
     }
}

void plugin_Keyboard_Save() {
     if(txtbMain->txtbPath[0] != 0) {
          txtbSave(txtbMain, txtbMain->txtbPath, 0);
          return;
     }
     char* tempSaveFile = fileBrowserOpen(60, 36, "Save ASCII Text File...");
     if((filesysFileExists(tempSaveFile) == 0) || (dlgConfirmOverwrite() != 0)) {
          if(tempSaveFile != NULL) {
               txtbSave(txtbMain, tempSaveFile, 0);
               recentFilesAdd(tempSaveFile);
          }
     }
}

void plugin_Keyboard_Help() {
     if((txtbMain->txtbChanged == 0) || (dlgHelp("README") != 0))
          txtbOpen(txtbMain, "README", 1);
}

void plugin_Keyboard_Find() {
     dlgFind();
}

void plugin_Keyboard_Replace() {
     dlgReplace();
}

void plugin_Keyboard_Exit() {
     terminate();
}
