#include <psptypes.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "error.h"
#include "main.h"
#include "filesys.h"
#include "dialog.h"
#include "recentFiles.h"

recentFileEntry recentFiles[10];

void recentFilesLoad() {
     memset(recentFiles, 0, 7680);
     if(filesysFileExists("settings/recent.lst") <= 0)
          return;
     FILE* tempFile = fopen("settings/recent.lst", "rb");
     if(tempFile == NULL) {
          errorThrow("File error, opening 'settings/recent.lst'.\nProgram stable.");
          return;
     }
     int i;
     for(i = 0; i < 10; i++)
          fread(recentFiles[i].rfeName, 1, sizeof(recentFileEntry), tempFile);
     fclose(tempFile);
}

void recentFilesSave() {
     if(filesysIsFile("./settings") != 0)
          filesysMkdir("./settings");
     FILE* tempFile = fopen("settings/recent.lst", "wb");
     if(tempFile == NULL) {
          errorThrow("File error, opening 'settings/recent.lst'.\nProgram stable.");
          return;
     }
     int i;
     for(i = 0; i < 10; i++)
          fwrite(recentFiles[i].rfeName, 1, sizeof(recentFileEntry), tempFile);
     fclose(tempFile);
}

void recentFilesAdd(char* inPath) {
     int i;
     for(i = 8; i >= 0; i--)
          strcpy(recentFiles[i + 1].rfeName, recentFiles[i].rfeName);
     strcpy(recentFiles[0].rfeName, inPath);
     recentFiles[0].rfeName[strlen(inPath)] = 0;
}

char* recentFilesGet(int inIndex) {
     return recentFiles[inIndex].rfeName;
}
