#ifndef SPRITE_H
#define SPRITE_H

#define SPRITE_ALPHA_COLOR 0xFFFF00FF

#include <psptypes.h>
#include "graphics.h"

typedef struct {
        Image* spriteData;
        int spriteWidth, spriteHeight;
        int spriteFrames, spriteCurFrame;
} Sprite;

extern Sprite* spriteLoad(char* inPath, int inWidth, int inHeight, int inFrames);
extern Sprite* spriteLoadAuto(char* inPath, int inWidth, int inHeight);
extern void spriteDraw(Sprite* inSprite, int inX, int inY);
extern void spriteDrawFrame(Sprite* inSprite, int inX, int inY, int inFrame);
extern void spriteDrawAnim(Sprite* inSprite, int inX, int inY);
extern void spriteFree(Sprite* inSprite);

#endif
