#include <psptypes.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include "textfield.h"
#include "graphics.h"
#include "font.h"
#include "error.h"
#include "main.h"
#include "keyboard.h"
#include "filesys.h"
#include "dialog.h"
#include "settings.h"
#include "input.h"

TextField* txtfCreate(int inLeft, int inTop, int inSize, Font* inFont) {
     TextField* tempTextField = (TextField*) malloc(sizeof(TextField));
     tempTextField->txtfText = (unsigned char*) malloc((inSize + 1) * sizeof(char));
     tempTextField->txtfText[0] = 0;
     tempTextField->txtfSize = inSize;
     tempTextField->txtfLeft = inLeft;
     tempTextField->txtfTop = inTop;
     tempTextField->txtfFont = inFont;
     tempTextField->txtfWidth = (inSize * (inFont->fontWidth + 1)) + 1;
     tempTextField->txtfHeight = (inFont->fontHeight + 4);
     return tempTextField;
}

void txtfTick(TextField* inTextField) {
     //TODO
}

void txtfDraw(TextField* inTextField) {
     fontSetColor(txtbForeColor);
     screenDrawFilledRect(inTextField->txtfLeft, inTextField->txtfTop, inTextField->txtfWidth, inTextField->txtfHeight, txtbBackColor);
     screenDrawRect(inTextField->txtfLeft, inTextField->txtfTop, inTextField->txtfWidth, inTextField->txtfHeight, menuBorderColor);
     fontPrint((inTextField->txtfLeft + 1), (inTextField->txtfTop + 2), (char*)inTextField->txtfText, inTextField->txtfFont);
}

void txtfAddChar(TextField* inTextField, unsigned char inChar) {
     int tempPtr = 0;
     while(inTextField->txtfText[tempPtr] != 0) {
          tempPtr++;
          if(tempPtr == inTextField->txtfSize)
               return;
     }
     inTextField->txtfText[tempPtr] = inChar;
     inTextField->txtfText[tempPtr + 1] = 0;
}

void txtfBackSpace(TextField* inTextField) {
     int tempPtr = 0;
     while(inTextField->txtfText[tempPtr] != 0)
          tempPtr++;
     tempPtr--;
     inTextField->txtfText[tempPtr] = 0;
}

unsigned char* txtfFree(TextField* inTextField) {
     unsigned char* tempOut = inTextField->txtfText;
     free(inTextField);
     return tempOut;
}
