#ifndef TEXTFIELD_H
#define TEXTFIELD_H

#include <psptypes.h>
#include "font.h"

typedef struct {
     unsigned char* txtfText;
     int txtfLeft, txtfTop, txtfWidth, txtfHeight;
     int txtfSize;
     Font* txtfFont;
} TextField;

extern TextField* txtfCreate(int inLeft, int inTop, int inSize, Font* inFont);
extern void txtfTick(TextField* inTextField);
extern void txtfDraw(TextField* inTextField);
extern void txtfAddChar(TextField* inTextField, unsigned char inChar);
extern void txtfBackSpace(TextField* inTextField);
extern unsigned char* txtfFree(TextField* inTextField);

#endif
