#include <stdio.h>
#include <stdlib.h>
#include <psptypes.h>
#include <psprtc.h>
#include <malloc.h>
#include "timer.h"
#include "error.h"

u64 timerPauseUntil = 0;

Timer* timerCreate() {
     Timer* tempTimer = (Timer*) malloc(sizeof(Timer));
     if(!tempTimer) {
          errorThrow("Couldn't create timer.\nOut of memory.");
          return NULL;
     }
     tempTimer->timerTimeNow = 0;
     sceRtcGetCurrentTick(&tempTimer->timerTimeLast);
     tempTimer->timerTickResolution = sceRtcGetTickResolution();
     return tempTimer;
}

double timerGetDeltaTime(Timer* inTimer) {
     if(inTimer->timerTimeLast < timerPauseUntil)
          inTimer->timerTimeLast = timerPauseUntil;
     sceRtcGetCurrentTick(&inTimer->timerTimeNow);
     double tempDeltaTime = (inTimer->timerTimeNow - inTimer->timerTimeLast) / ((float) inTimer->timerTickResolution );
     inTimer->timerTimeLast = inTimer->timerTimeNow;
 
     return tempDeltaTime;
}

void timerPauseAll() {
     sceRtcGetCurrentTick(&timerPauseUntil);
}

void timerFree(Timer* inTimer) {
     free(inTimer);
}
